################################################################################
# ModuleName  : com
# $File$
# $Author$
# $Date$
################################################################################
# Description :
# usage: python generatemoid.py <args>
# create moId.h
################################################################################
import sys
import string
import os
import xml.dom.minidom
from string import Template
import time
import getpass

mainTemplate = Template("""\
/******************************************************************************
 *
 * clMOID.h
 *
 ******************************************************************************
 * This code is auto-generated by OpenClovis IDE Version 3.1
 *
 ***************************** Description ************************************
 *
 * 
 *****************************************************************************/
#ifndef _CL_MOID__H_
#define _CL_MOID_H_
#ifdef __cplusplus
extern "C"
{
#endif

${moIDs}

#ifdef __cplusplus
}
#endif
#endif /* _CL_MOID_H_*/

""")

moIdTemplate = Template("""\
#define ${moIdString} "${moId}"
""")

def generateMoIds(nodeInstanceList):
	out_file = open("clMOID.h","w")
	moIDs = ""
	map = dict()
	for nodeInst in nodeInstanceList:
		nodeName = nodeInst.attributes["name"].value
		node_rtfile = configDir + filePathSeparator + nodeName + "_rt.xml"
		if os.path.exists(node_rtfile):
			rtDoc = xml.dom.minidom.parse(node_rtfile) 
			resMoIdList = rtDoc.getElementsByTagName("resource")
			uniqueMoIdList = []
			
			for resMoId in resMoIdList:
				moId = resMoId.attributes["moID"].value
				if  uniqueMoIdList.count(moId) == 0:
					uniqueMoIdList.append(moId)
					map1 = dict();
					moIdString_ = moId.replace(":","_")
					moIdString = moIdString_.replace("\\","_")
					moIdString = moIdString.lstrip("_")
					length = len(moId)
					if moId[length-1] == "\\":
						moId = moId[:length-1]
					map1['moId'] = moId
					moIdString = moIdString.replace("*", "All")
					map1['moIdString'] = moIdString
					moIDs += moIdTemplate.safe_substitute(map1)
						
	map['moIDs'] = moIDs			
	out_file.write(mainTemplate.safe_substitute(map))
	out_file.close()

#Script execution starts here
configDir = sys.argv[1];
filePathSeparator = '/'
amfConfigXml = configDir + filePathSeparator + "clAmfConfig.xml"
if os.path.exists(amfConfigXml):
	amfDoc = xml.dom.minidom.parse(amfConfigXml) 
	nodeInstanceList = amfDoc.getElementsByTagName("nodeInstance")
	generateMoIds(nodeInstanceList)
